% code by annika and jph
function demo
  global X T
  
  X=rand(3,40);
  T=delaunay(X(1,:),X(2,:)); T=T';
  
  figure(1)
  subplot(2,2,1);
  trimesh(T',X(1,:),X(2,:),X(3,:))
  title('input triangular mesh')
  
  jdemo(2,[2 2 2]);
  jdemo(3,[0 1])
  jdemo(4,[0 1 1 1])
  set(1,'Color',[.9 .9 .9]);

function jdemo(n,s)
  global X T
  [x,t]=subdivision(X,T,s);
  subplot(2,2,n);
  trimesh(t',x(1,:),x(2,:),x(3,:))
  title(['subdivision with parameters: ' num2str(s)])
