% code by jph
function demo
  t=linspace(.1,.9,8);
  o=ones(1,8);
  z=zeros(1,8);
  X=[rand(3,30) [z o t t;t t z o;z z o o]];
  T=delaunay(X(1,:),X(2,:)); T=T';
  Q=[];
  %begin: replace two adjacent triangles by single quad
  for c1=1:30
    c=find(sum(T==T(1,1)|T==T(2,1))==2);
    if length(c)==2
      c2=c(2);
      Q=[Q [T([2 3 1],1);T(find(T(:,c2)~=T(1,1)&T(:,c2)~=T(2,1)),c2)]];
      T(:,[1 c2])=[];
    end
    T(:,randperm(size(T,2)))=T;
  end
  %end: replace two adjacent triangles by single quad
  
  figure(1)
  clf reset    
  subplot(1,2,1); jidemo(X,T,Q)
  
  [x,t,q]=subdivision(X,T,Q,[0 1 1 1]); %subdivision algorithm  
  
  subplot(1,2,2); jidemo(x,t,q)  
  set(1,'Color',[.9 .9 .9]);
  
function jidemo(X,T,Q)
  trimesh(T',X(1,:),X(2,:),0*X(2,:));
  view(0,90)
  hold on
  for c1=1:length(Q)
    patch(X(1,Q(:,c1)),X(2,Q(:,c1)),0*X(3,Q(:,c1)),X(3,Q(:,c1)))
  end
  grid off
  axis equal
  axis off
