//special file operations, please note that binary storage in/out is
//in mesh.hpp file                          ------------------- jph 2004

//adds faces from file to shape type (and verts) see code for extrentions
//note, not the same as the constructor that takes in char *fn.
void addFile(int typ,char *fn) {
	char fnc[80];
	if (typ<MESH_JAYA) {
		sprintf(fnc,"%s.ind",fn); array<int> find(fnc);		
		find+=arr->size[1];			 //indices need to be increased
		*ind[typ]|=find;
		sprintf(fnc,"%s.arr",fn); addVerts(array<type>(fnc));
	}
	if (typ==MESH_JAYA) {
		int c1;
		matrix<int> size(MESH_MAX,1);
		sprintf(fnc,"%s.mfs",fn); array<int> find(fnc);
		int cnt=0,fl;
		while (fl=find.data[cnt]) {
			size.data[MESH_JAYAIND[fl]]++;
			cnt+=fl+1;
		}
		int sz[2];
		array<int> *tind[MESH_MAX];
		for (c1=0;c1<MESH_MAX;c1++) {
			sz[0]=MESH_COMP[c1]; sz[1]=size.data[c1];
			tind[c1]=new array<int>(2,sz,0);
		}
		while (fl=find.token())
			for (c1=0;c1<fl;c1++)
				*tind[MESH_JAYAIND[fl]]<=find.token();
		int tmp[3]; //ugly index reordering for octa :-(
		for (c1=0;c1<tind[MESH_OCTA]->numel;c1+=MESH_COMP[MESH_OCTA]) {
			memcpy( tmp                 ,*tind[MESH_OCTA]^c1  ,12);
			memcpy(*tind[MESH_OCTA]^c1  ,*tind[MESH_OCTA]^c1+3,12);
			memcpy(*tind[MESH_OCTA]^c1+3, tmp                 ,12);
		}			
		for (c1=0;c1<MESH_MAX;c1++) {
			*tind[c1]+=arr->size[1];
			*ind[c1]|=*tind[c1]; //indecees need to be increased!!!
			delete tind[c1];
		}
		sprintf(fnc,"%s.mv3",fn); addVerts(array<type>(fnc));		
	}
	if (typ==MESH_TXT) {
		int c1,c2,c3,typ,sz[2];
		char tok,buf[512];
	  ifstream fid(fn);
  	if (fid.is_open()) 
  		while (!fid.eof()) {    		
	  		*buf=0;
    		fid >> buf;
    		//cout << "---HERE*********-----" << endl;
    		if (*buf==37) {
	    		fid.getline(buf,511);
	    		//cout << buf << endl;
    		}
				if (*buf==102) {
    			fid >> typ >> sz[1];
    			sz[0]=MESH_COMP[typ];
    			array<int> tmp(2,sz,0);
    			for (c1=0;c1<MESH_COMP[typ]*sz[1];c1++) fid >> tmp[c1];
    			*ind[typ]|=tmp;
  			}
				if (*buf==118) {
    			fid >> sz[0] >> sz[1];
    			//cout <<  sz[0] << sz[1] << endl;
    			matrix<type> tmp(sz[0],sz[1]);
    			for (c1=0;c1<sz[0]*sz[1];c1++) fid >> tmp[c1];
    			arr->stretch(sz[0],0);
    			//cout << *arr;    			
    			*arr|=tmp;
    			//cout << "------------------------------------------" << endl;
    			//cout << *arr;
  			}
    	}
	}
}

void storeTxt(char *fn) {
	int c1,c2,c3;
	ofstream fid(fn);
  if (fid.is_open()) {
   	fid << "% file generated by mesh3d - for more documentation: www.hakenberg.de/subdiv\n";
   	fid << "% note: - vertex indices begin counting from 0\n";
   	fid << "%       - blank lines are ignored\n\n";
   	for (c1=0;c1<MESH_MAX;c1++) {
	   	fid << "f " << c1 << " " << ind[c1]->size[1] << endl;
	   	for (c2=0;c2<ind[c1]->size[1];c2++) {
		   	for (c3=0;c3<MESH_COMP[c1];c3++) fid << ind[c1]->token() << " ";
		   	fid << endl;
	   	}
   		fid << endl; 
 		}
 		fid << "v " << arr->size[0] << " " << arr->size[1] << "\n";
		for (c2=0;c2<arr->size[1];c2++) {
   		for (c3=0;c3<arr->size[0];c3++) fid << arr->token() << " ";
   		fid << endl;
 		}
  }
  fid.close();
}
