function demo

X=[0 0 1;1 0 0;0 1 0]*xload('float','dino50.mv3');
A=xload('int','dino50.mfs');
cnt=1; T=[]; O=[];
while cnt<length(A)
  l=A(cnt);
  switch l
    case 4, T=[T A(cnt+1:cnt+4)+1];
    case 6, O=[O A(cnt+1:cnt+6)+1];
  end
  cnt=cnt+1+l;
end

disp('please hold on for a few seconds')
disp('for subdivision and drawing ...')

figure(1)
clf reset
subplot('Position',[0.025 0.5125 .45 .45])
jdrwmesh(X,T,O)
title('input tetra- and octahedra mesh')
ax=axis;
axis off

[x,t,o,b]=subdivision(X,T,O,[0 1]);
subplot('Position',[0.5125 0.5125 .45 .45])
jdrwmesh(x,t,o)
title(['subdivision with parameters: ' num2str([0 1])])
axis off

tic;
[x,t,o,b]=subdivision(X,T,O,[0 1 1]);
tim=toc;
f=find(x(3,:)>10);
t(:,~all(ismember(t,f)))=[];
o(:,~all(ismember(o,f)))=[];
subplot('Position',[0.0125 0.0125 .45 .45])
jdrwmesh(x,t,o)
title(['parameters: ' num2str([0 1 1]) '   time: ' num2str(tim) ' sec'])
axis off
text(0,5,11,'close up')

tic;
[x,t,o,b]=subdivision(X,T,O,[0 1 1 1]);
tim=toc;
subplot('Position',[0.5125 0.0125 .45 .45])
trimesh(b',x(1,:),x(2,:),x(3,:))
title(['parameters: ' num2str([0 1 1 1]) '   time: ' num2str(tim) ' sec'])
axis(ax)
axis equal
axis off
text(0,0,13,'only boundary shown')

set(1,'Color',[.9 .9 .9]);

function jdrwmesh(X,T,O)

ind=[1 2 3 1 4 2 3 4];
for c1=T
  c2=c1(ind);
  plot3(X(1,c2),X(2,c2),X(3,c2)); hold on;
end
ind=[1 2 3 1 5];
for c1=O
  c2=c1(ind);
  plot3(X(1,c2),X(2,c2),X(3,c2),'r');
end
ind=[1 6 4 5 6 2 4 3 5];
for c1=O
  c2=c1(ind);
  plot3(X(1,c2),X(2,c2),X(3,c2),'r');
end
axis equal
